#include "File.h"

File::File(std::wstring lpath) : path(lpath)
{
	file = NULL;
	file_mapping = NULL;
	ptr_tofile = NULL;
}

File::~File()
{
	if (file_mapping != NULL)
	{
		FlushViewOfFile(ptr_tofile, 0);
		UnmapViewOfFile(ptr_tofile);
		CloseHandle(file_mapping);
	}
	if (file == NULL)
		CloseHandle(file);
}

void *File::MapToRAM()
{
	if (file == NULL)
		file = getHandle();

	if (file_mapping == NULL)
	{
		file_mapping = CreateFileMapping(file, NULL, PAGE_READWRITE, 0, 0, NULL);
		if (file_mapping == NULL)
			return NULL;
		ptr_tofile = MapViewOfFile(file_mapping, FILE_MAP_READ | FILE_MAP_WRITE, 0, 0, 0);
	}

	return ptr_tofile;
}

int File::getFileSize()
{
	file = getHandle();
	int size =  GetFileSize(file, NULL);
	return size;
}

HANDLE File::getHandle()
{
	HANDLE HFile = CreateFile(path.c_str(), GENERIC_ALL, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (file == INVALID_HANDLE_VALUE)
	{
		throw  new std::exception("Error on file open");
	}

	return HFile;
}

File &File::copy(std::wstring new_path)
{
	CopyFile(path.c_str(), new_path.c_str(), false);
	File *nPath = new File(new_path);

	return *nPath;
}